#include<stdio.h>
#include<stdlib.h>
#include<stddef.h>

#include "texs.h"

#define  align(d)	(((d) + (sizeof(void *) - 1)) & (~(sizeof(void *) - 1)))
#include"heap.h"

Public heap *
heap_create(long block_size)          /* allocates memory for heap */

{
    heap *HEAP;

    HEAP = (heap *)malloc(sizeof(heap));
    if(HEAP == NULL)
       {
	fprintf(stderr, "Can't allocate memory\n");
	exit(-3);
       }
    HEAP->first = (struct heap_block *)malloc(align(block_size) +
			    sizeof(struct heap_block) - sizeof(unsigned char));
    if(HEAP->first == NULL)
       {
	fprintf(stderr, "Can't allocate memory\n");
	exit(-3);
       }
    HEAP->last = HEAP->first;
    HEAP->blocksize = align(block_size);
    HEAP->top_of_heap = HEAP->last->block;
    HEAP->first->next = NULL;
    HEAP->free = HEAP->blocksize;
    return(HEAP);
}

Public void *
heap_allocate(heap *HEAP, long size)

{
    void *help;

    if(HEAP->free < size)
       {
	if((HEAP->last->next = (struct heap_block *)
			malloc(HEAP->blocksize + sizeof(struct heap_block) - 
					      sizeof(unsigned char))) == NULL)
	   {
	    fprintf(stderr, "Can't allocate memory\n");
	    exit(-3);
	   }
	HEAP->last = HEAP->last->next;
	HEAP->last->next = NULL;
	HEAP->free = HEAP->blocksize;
	HEAP->top_of_heap = HEAP->last->block;
       }
    if(HEAP->free < size)
       {
	fprintf(stderr, "Internal: memory segment to small\n");
	exit(-3);
       }
    help = (void *)HEAP->top_of_heap;
    size = (align(size) + sizeof(char) - 1) / sizeof(char);
    HEAP->top_of_heap += size;
    HEAP->free -= size;
    return(help);
}

Public void *
heap_delete(heap *HEAP)

{
    struct heap_block *temp, 
                      *next;

    temp = HEAP->first;

    free(HEAP);
    while(temp != NULL)
       {
	next = temp->next;
	free(temp);
	temp = next;
       }
    return(NULL);
}
