struct libnode
   {
    struct libnode *left;
    struct libnode *right;
    struct libnode *link;
    int            action_type;
    unsigned char  string[1];		/* musi byc na koncu!!! */
  };

typedef struct
   {
    struct libnode *root;
    heap           *lib_on_which_heap;
    long           number_of_entries;
   }library; 

Global library *library_create(long blocksize);
Global Logical search_and_set(library *lib, struct libnode **dest, 
						const unsigned char *string);
Global void library_read(library *lib, FILE *libfile);
Global Logical library_find_entry(library *lib, const unsigned char *string);
Global int read_string(FILE *file, unsigned char *buffer, int max_len);
Global void next_line(FILE *file);
Global void write_tree(struct libnode *root, FILE *libfile);

#define library_write(lib, file)    write_tree(lib->root, file)
#define library_enter_entry(lib, string)  \
				(void)search_and_set(lib, &(lib->root), string)
#define library_delete(lib) 	lib = heap_delete(lib->lib_on_which_heap)
